// Generated by gmmproc 2.46.1 -- DO NOT MODIFY!


#include <glibmm.h>

#include <libgdamm/batch.h>
#include <libgdamm/private/batch_p.h>


// -*- C++ -*- // this is for the .ccg, I realize gensig puts one in

/* batch.cc
 * 
 * Copyright 2003 libgdamm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <libgdamm/batch.h>
#include <libgda/gda-batch.h>


namespace Gnome
{

namespace Gda
{

//Fix compilation of our generated code:
typedef Batch::StatementVector StatementVector;


bool Batch::get_parameters(Glib::RefPtr<Set>& out_params)
{
  GError* gerror = 0;
  GdaSet* set = 0;
  const bool retval = gda_batch_get_parameters(gobj(), &set, &gerror);

  if(gerror)
    ::Glib::Error::throw_exception(gerror);

  if(set)
  {
    out_params = Glib::wrap(set);
  }
  return retval;
}
  
}

} /* namespace Gnome */


namespace
{


static void Batch_signal_changed_callback(GdaBatch* self, GObject* p0,void* data)
{
  using namespace Gnome::Gda;
  typedef sigc::slot< void,Glib::RefPtr<Statement> > SlotType;

  auto obj = dynamic_cast<Batch*>(Glib::ObjectBase::_get_current_wrapper((GObject*) self));
  // Do not try to call a signal on a disassociated wrapper.
  if(obj)
  {
    try
    {
      if(const auto slot = Glib::SignalProxyNormal::data_to_slot(data))
        (*static_cast<SlotType*>(slot))(Glib::wrap(GDA_STATEMENT(p0))
);
    }
    catch(...)
    {
       Glib::exception_handlers_invoke();
    }
  }
}

static const Glib::SignalProxyInfo Batch_signal_changed_info =
{
  "changed",
  (GCallback) &Batch_signal_changed_callback,
  (GCallback) &Batch_signal_changed_callback
};


} // anonymous namespace


namespace Glib
{

Glib::RefPtr<Gnome::Gda::Batch> wrap(GdaBatch* object, bool take_copy)
{
  return Glib::RefPtr<Gnome::Gda::Batch>( dynamic_cast<Gnome::Gda::Batch*> (Glib::wrap_auto ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} /* namespace Glib */


namespace Gnome
{

namespace Gda
{


/* The *_Class implementation: */

const Glib::Class& Batch_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &Batch_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(gda_batch_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:

  }

  return *this;
}


void Batch_Class::class_init_function(void* g_class, void* class_data)
{
  const auto klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);


}


Glib::ObjectBase* Batch_Class::wrap_new(GObject* object)
{
  return new Batch((GdaBatch*)object);
}


/* The implementation: */

GdaBatch* Batch::gobj_copy()
{
  reference();
  return gobj();
}

Batch::Batch(const Glib::ConstructParams& construct_params)
:
  Glib::Object(construct_params)
{

}

Batch::Batch(GdaBatch* castitem)
:
  Glib::Object((GObject*)(castitem))
{}


Batch::Batch(Batch&& src) noexcept
: Glib::Object(std::move(src))
{}

Batch& Batch::operator=(Batch&& src) noexcept
{
  Glib::Object::operator=(std::move(src));
  return *this;
}

Batch::~Batch() noexcept
{}


Batch::CppClassType Batch::batch_class_; // initialize static member

GType Batch::get_type()
{
  return batch_class_.init().get_type();
}


GType Batch::get_base_type()
{
  return gda_batch_get_type();
}


Batch::Batch()
:
  // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Glib::Object(Glib::ConstructParams(batch_class_.init()))
{
  

}

Glib::RefPtr<Batch> Batch::create()
{
  return Glib::RefPtr<Batch>( new Batch() );
}

Glib::RefPtr<Batch> Batch::copy()
{
  return Glib::wrap(gda_batch_copy(gobj()));
}

void Batch::add_statement(const Glib::RefPtr<Statement>& stmt)
{
  gda_batch_add_statement(gobj(), Glib::unwrap(stmt));
}

void Batch::remove_statement(const Glib::RefPtr<Statement>& stmt)
{
  gda_batch_remove_statement(gobj(), Glib::unwrap(stmt));
}

Glib::ustring Batch::serialize() const
{
  return Glib::convert_return_gchar_ptr_to_ustring(gda_batch_serialize(const_cast<GdaBatch*>(gobj())));
}

StatementVector Batch::get_statements() const
{
  return StatementVector(Glib::SListHandler<Glib::RefPtr<const Statement> >::slist_to_vector((GSList*)gda_batch_get_statements(const_cast<GdaBatch*>(gobj())), Glib::OWNERSHIP_NONE));
}


Glib::SignalProxy1< void,Glib::RefPtr<Statement> > Batch::signal_changed()
{
  return Glib::SignalProxy1< void,Glib::RefPtr<Statement> >(this, &Batch_signal_changed_info);
}


} // namespace Gda

} // namespace Gnome


